### A free/open-source library for quantitative finance

Public Member Functions | Protected Attributes
Instrument Class Reference

Abstract instrument class. More...

`#include <ql/instrument.hpp>`

Inherits LazyObject.

Inherited by Bond, CapFloor, CDO, Commodity, CompositeInstrument, CPICapFloor, CreditDefaultSwap, Forward, NthToDefault, Option, PathMultiAssetOption, RiskyAssetSwap, RiskyAssetSwapOption, RiskyBond, Stock, Swap, SyntheticCDO, VarianceOption, VarianceSwap, and YoYInflationCapFloor.

List of all members.

## Public Member Functions

virtual void | setupArguments (PricingEngine::arguments *) const
virtual void | fetchResults (const PricingEngine::results *) const
Inspectors
Real | NPV () const
| returns the net present value of the instrument.
Real | errorEstimate () const
| returns the error estimate on the NPV when available.
const Date & | valuationDate () const
| returns the date the net present value refers to.
template<typename T >
T | result (const std::string &tag) const
| returns any additional result returned by the pricing engine.
const std::map< std::string, boost::any > & | additionalResults () const
| returns all additional result returned by the pricing engine.
virtual bool | isExpired () const =0
| returns whether the instrument might have value greater than zero.
Modifiers
void | setPricingEngine (const boost::shared_ptr< PricingEngine > &)
| set the pricing engine to be used.

## Protected Member Functions

Calculations
void | calculate () const
virtual void | setupExpired () const
virtual void | performCalculations () const

## Protected Attributes

boost::shared_ptr< PricingEngine > | engine_
Results
The value of this attribute and any other that derived classes might declare must be set during calculation.
Real | NPV_
Real | errorEstimate_
Date | valuationDate_
std::map< std::string, boost::any > | additionalResults_

## Detailed Description

Abstract instrument class.

This class is purely abstract and defines the interface of concrete instruments which will be derived from this one.

Tests:
  observability of class instances is checked.

## Member Function Documentation

void setPricingEngine | ( | const boost::shared_ptr< PricingEngine > & | e | ) |

set the pricing engine to be used.

Warning:
  calling this method will have no effects in case the performCalculation method was overridden in a derived class.

void setupArguments | ( | PricingEngine::arguments * |  | ) | const`[virtual]`

When a derived argument structure is defined for an instrument, this method should be overridden to fill it. This is mandatory in case a pricing engine is used.

Reimplemented in Bond, CallableFixedRateBond, SyntheticCDO, CPISwap, CreditDefaultSwap, ZeroCouponInflationSwap, VanillaSwap, YearOnYearInflationSwap, EnergyCommodity, CPICapFloor, AssetSwap, CallableBond, Swaption, YoYInflationCapFloor, CapFloor, DiscreteAveragingAsianOption, VarianceSwap, VanillaSwingOption, VarianceOption, ContinuousFixedLookbackOption, Swap, DividendVanillaOption, ForwardVanillaOption, CdsOption, CliquetOption, WriterExtensibleOption, MultiAssetOption, HimalayaOption, PagodaOption, BarrierOption, PathMultiAssetOption, DividendBarrierOption, ContinuousAveragingAsianOption, CompoundOption, VanillaStorageOption, MargrabeOption, SimpleChooserOption, Option, and ContinuousFloatingLookbackOption.

void fetchResults | ( | const PricingEngine::results * | r | ) | const`[virtual]`

When a derived result structure is defined for an instrument, this method should be overridden to read from it. This is mandatory in case a pricing engine is used.

Reimplemented in Bond, SyntheticCDO, CPISwap, CreditDefaultSwap, ZeroCouponInflationSwap, VanillaSwap, YearOnYearInflationSwap, EnergyCommodity, CPICapFloor, AssetSwap, VarianceSwap, QuantoVanillaOption, Swap, OneAssetOption, ForwardVanillaOption, MultiAssetOption, QuantoBarrierOption, MargrabeOption, and QuantoForwardVanillaOption.

void calculate | ( |  | ) | const`[protected, virtual]`

This method performs all needed calculations by calling the performCalculations method.

Warning:
  Objects cache the results of the previous calculation. Such results will be returned upon later invocations of calculate. When the results depend on arguments which could change between invocations, the lazy object must register itself as observer of such objects for the calculations to be performed again when they change.

Warning:
  Should this method be redefined in derived classes, LazyObject::calculate() should be called in the overriding method.

Reimplemented from LazyObject.

void setupExpired | ( |  | ) | const`[protected, virtual]`

This method must leave the instrument in a consistent state when the expiration condition is met.

Reimplemented in CreditDefaultSwap, Bond, Swap, RiskyBond, VarianceSwap, OneAssetOption, MultiAssetOption, and PathMultiAssetOption.

void performCalculations | ( |  | ) | const`[protected, virtual]`

In case a pricing engine is not used, this method must be overridden to perform the actual calculations and set any needed results. In case a pricing engine is used, the default implementation can be used.

Implements LazyObject.

Reimplemented in FixedRateBondForward, Forward, RiskyBond, ConvertibleBond, CompositeInstrument, EnergyVanillaSwap, EnergyBasisSwap, EnergyFuture, and Stock.